#!/usr/bin/perl5 -Tw

use strict;

use CGI;
use CGI::Carp;

##############################################################################
#
# $Id: config.pl,v 1.1.1.1 2003/09/23 17:27:50 rusfidogate Exp $
#
# Perl functions to read FIDOGATE config file,
# included by <INCLUDE config.pl> when running subst.pl
#

my %CONFIG;

# specials for DosDrive and Zone
my %CONFIG_dosdrive;
my %CONFIG_zone;



my %CONFIG_default =
    (
##Automatically generated by subst.pl, DO NOT EDIT!!!##
	"seq_split", "%V/seq/split",
	"libexecdir", "/usr/lib/fidogate",
	"toss_toss", "%S/toss/toss",
	"passwd", "%C/passwd",
	"tick_hold", "%B/tick",
	"vardir", "/var/lib/fidogate",
	"lockdir", "/var/lock/fidogate",
	"inbound", "/var/spool/ftn/in",
	"toss_route", "%S/toss/route",
	"btbasedir", "/var/spool/ftn",
	"outpkt_mail", "%S/outpkt/mail",
	"lock_history", "history",
	"newsbindir", "/none/news-pathbin",
	"newsvardir", "/none/news-pathdb",
	"spyes", "%C/spyes",
	"aliases", "%C/aliases",
	"toss_bad", "%S/toss/bad",
	"seq_news", "%V/seq/news",
	"hosts", "%C/hosts",
	"seq_tick", "%V/seq/tick",
	"tic_history", "%V/tic_hist",
	"outrfc_news", "%S/outrfc/news",
	"hubroutedb", "%V/route",
	"pinbound", "/var/spool/ftn/pin",
	"outrfc_mail", "%S/outrfc/mail",
	"spooldir", "/var/spool/fidogate",
	"newsetcdir", "/none/news-pathetc",
	"libdir", "/usr/local/fido/lib",
	"outpkt", "%S/outpkt",
	"inn_batchdir", "/none/news-pathoutgoing",
	"history", "%V/history",
	"logdir", "/var/log/fidogate",
	"packing", "%C/packing",
	"toss_pack", "%S/toss/pack",
	"seq_ff", "%V/seq/ff",
	"bindir", "/usr/bin",
	"configdir", "/etc/fidogate",
	"dbc_history", "%V/bdc",
	"newslibdir", "/none/news-pathnews",
	"seq_mail", "%V/seq/mail",
	"config_gate", "%C/fidogate.conf",
	"charsetmap", "%L/charset.bin",
	"seq_msgid", "%V/seq/msgid",
	"seq_pack", "%V/seq/pack",
	"lock_tic_hist", "tic_hist",
	"outpkt_news", "%S/outpkt/news",
	"seq_pkt", "%V/seq/pkt",
	"acl", "%C/acl",
	"ftnacl", "%C/ftnacl",
	"logfile", "%G/log",
	"uplinks", "%C/uplinks",
	"lock_dbc", "dbc",
	"seq_toss", "%V/seq/toss",
	"config_main", "%C/fidogate.conf",
	"areas", "%C/areas",
	"routing", "%C/routing",
	"newsspooldir", "/none/news-patharticles",
     );
my %CONFIG_abbrev =
    (
##Automatically generated by subst.pl, DO NOT EDIT!!!##
	"L", "libexecdir",
	"G", "logdir",
	"V", "vardir",
	"K", "lockdir",
	"P", "pinbound",
	"I", "inbound",
	"C", "configdir",
	"N", "bindir",
	"S", "spooldir",
	"B", "btbasedir",
     );



sub CONFIG_read {
    my($file) = @_;
    my($key, $arg);
    local *C;

    $file = CONFIG_expand($file);

    open(C,"$file") || die "config.pl: can't open config file $file\n";
    while(<C>) {
	chop;
	next if( /^\s*\#/ );	# comments
	next if( /^\s*$/  );	# empty
	s/\s*$//;		# remove trailing white space
	s/^\s*//;		# remove leading white space
	($key,$arg) = split(' ', $_, 2);
	$key =~ tr/A-Z/a-z/;
	if($key eq "include") {
	    CONFIG_read($arg);
	    next;
	}
	if($key eq "dosdrive") {
	    my ($d, $path) = split(' ', $arg);
	    $CONFIG_dosdrive{lc($d)} = $path;
	    next;
	}
	if($key eq "zone") {
	    my ($z, $rest) = split(' ', $arg, 2);
	    $CONFIG_zone{$z} = $rest;
	    next;
	}
	$CONFIG{$key} = $arg if(!$CONFIG{$key});
    }
    close(C);
}


sub CONFIG_get1 {
    my($key) = @_;
    my($ukey);

    $ukey = $key;
    $ukey =~ tr/a-z/A-Z/;
    return $ENV{"FIDOGATE_$ukey"} if($ENV{"FIDOGATE_$ukey"});

    return $CONFIG{$key} if($CONFIG{$key});
    return $CONFIG_default{$key};
}


sub CONFIG_get {
    my($key) = @_;
    my($ret);
    my($exp);

    $key =~ tr/A-Z/a-z/;
    return CONFIG_expand( CONFIG_get1($key) );
}


sub CONFIG_expand {
    my($v) = @_;
    my($exp);

    if($v =~ /^%([A-Z])/) {
	$exp = CONFIG_get1($CONFIG_abbrev{$1});
	$v =~ s/^%./$exp/;
    }

    return $v;
}


sub CONFIG_debug {    
    my($key);

    for $key (keys %CONFIG) {
	print "$key = $CONFIG{$key} -> ", CONFIG_get($key), "\n";
    }
}

##############################################################################

$ENV{"PATH"} = "/bin:/usr/bin";
$ENV{"CDPATH"} = "";

##############################################################################
#
# $Id: config.pl,v 1.1.1.1 2003/09/23 17:27:50 rusfidogate Exp $
#
# Perl functions to read FIDOGATE config file,
# included by <INCLUDE config.pl> when running subst.pl
#

my %CONFIG;

# specials for DosDrive and Zone
my %CONFIG_dosdrive;
my %CONFIG_zone;



my %CONFIG_default =
    (
##Automatically generated by subst.pl, DO NOT EDIT!!!##
	"seq_split", "%V/seq/split",
	"libexecdir", "/usr/lib/fidogate",
	"toss_toss", "%S/toss/toss",
	"passwd", "%C/passwd",
	"tick_hold", "%B/tick",
	"vardir", "/var/lib/fidogate",
	"lockdir", "/var/lock/fidogate",
	"inbound", "/var/spool/ftn/in",
	"toss_route", "%S/toss/route",
	"btbasedir", "/var/spool/ftn",
	"outpkt_mail", "%S/outpkt/mail",
	"lock_history", "history",
	"newsbindir", "/none/news-pathbin",
	"newsvardir", "/none/news-pathdb",
	"spyes", "%C/spyes",
	"aliases", "%C/aliases",
	"toss_bad", "%S/toss/bad",
	"seq_news", "%V/seq/news",
	"hosts", "%C/hosts",
	"seq_tick", "%V/seq/tick",
	"tic_history", "%V/tic_hist",
	"outrfc_news", "%S/outrfc/news",
	"hubroutedb", "%V/route",
	"pinbound", "/var/spool/ftn/pin",
	"outrfc_mail", "%S/outrfc/mail",
	"spooldir", "/var/spool/fidogate",
	"newsetcdir", "/none/news-pathetc",
	"libdir", "/usr/local/fido/lib",
	"outpkt", "%S/outpkt",
	"inn_batchdir", "/none/news-pathoutgoing",
	"history", "%V/history",
	"logdir", "/var/log/fidogate",
	"packing", "%C/packing",
	"toss_pack", "%S/toss/pack",
	"seq_ff", "%V/seq/ff",
	"bindir", "/usr/bin",
	"configdir", "/etc/fidogate",
	"dbc_history", "%V/bdc",
	"newslibdir", "/none/news-pathnews",
	"seq_mail", "%V/seq/mail",
	"config_gate", "%C/fidogate.conf",
	"charsetmap", "%L/charset.bin",
	"seq_msgid", "%V/seq/msgid",
	"seq_pack", "%V/seq/pack",
	"lock_tic_hist", "tic_hist",
	"outpkt_news", "%S/outpkt/news",
	"seq_pkt", "%V/seq/pkt",
	"acl", "%C/acl",
	"ftnacl", "%C/ftnacl",
	"logfile", "%G/log",
	"uplinks", "%C/uplinks",
	"lock_dbc", "dbc",
	"seq_toss", "%V/seq/toss",
	"config_main", "%C/fidogate.conf",
	"areas", "%C/areas",
	"routing", "%C/routing",
	"newsspooldir", "/none/news-patharticles",
     );
my %CONFIG_abbrev =
    (
##Automatically generated by subst.pl, DO NOT EDIT!!!##
	"L", "libexecdir",
	"G", "logdir",
	"V", "vardir",
	"K", "lockdir",
	"P", "pinbound",
	"I", "inbound",
	"C", "configdir",
	"N", "bindir",
	"S", "spooldir",
	"B", "btbasedir",
     );



sub CONFIG_read {
    my($file) = @_;
    my($key, $arg);
    local *C;

    $file = CONFIG_expand($file);

    open(C,"$file") || die "config.pl: can't open config file $file\n";
    while(<C>) {
	chop;
	next if( /^\s*\#/ );	# comments
	next if( /^\s*$/  );	# empty
	s/\s*$//;		# remove trailing white space
	s/^\s*//;		# remove leading white space
	($key,$arg) = split(' ', $_, 2);
	$key =~ tr/A-Z/a-z/;
	if($key eq "include") {
	    CONFIG_read($arg);
	    next;
	}
	if($key eq "dosdrive") {
	    my ($d, $path) = split(' ', $arg);
	    $CONFIG_dosdrive{lc($d)} = $path;
	    next;
	}
	if($key eq "zone") {
	    my ($z, $rest) = split(' ', $arg, 2);
	    $CONFIG_zone{$z} = $rest;
	    next;
	}
	$CONFIG{$key} = $arg if(!$CONFIG{$key});
    }
    close(C);
}


sub CONFIG_get1 {
    my($key) = @_;
    my($ukey);

    $ukey = $key;
    $ukey =~ tr/a-z/A-Z/;
    return $ENV{"FIDOGATE_$ukey"} if($ENV{"FIDOGATE_$ukey"});

    return $CONFIG{$key} if($CONFIG{$key});
    return $CONFIG_default{$key};
}


sub CONFIG_get {
    my($key) = @_;
    my($ret);
    my($exp);

    $key =~ tr/A-Z/a-z/;
    return CONFIG_expand( CONFIG_get1($key) );
}


sub CONFIG_expand {
    my($v) = @_;
    my($exp);

    if($v =~ /^%([A-Z])/) {
	$exp = CONFIG_get1($CONFIG_abbrev{$1});
	$v =~ s/^%./$exp/;
    }

    return $v;
}


sub CONFIG_debug {    
    my($key);

    for $key (keys %CONFIG) {
	print "$key = $CONFIG{$key} -> ", CONFIG_get($key), "\n";
    }
}

##############################################################################

# read config
my $CONFIG = "%C/fidogate.conf";
CONFIG_read($CONFIG);


$NEWSVARDIR   = CONFIG_get("NEWSVARDIR");
$INN_BATCHDIR = CONFIG_get("INN_BATCHDIR");
$VARDIR	      = CONFIG_get("VARDIR");
$LOCKDIR      = CONFIG_get("$LOCKDIR");
$SPOOLDIR     = CONFIG_get("SPOOLDIR");
$BTBASEDIR    = CONFIG_get("BTBASEDIR");

my @DIRS = (
	    "$NEWSVARDIR",
	    "$INN_BATCHDIR",
	    "$VARDIR",
	    "$LOCKDIR",
	    "$SPOOLDIR/outpkt -R",
	    "$BTBASEDIR/in -R",
	    "$BTBASEDIR/pin -R",
	    "$BTBASEDIR/uuin -R",
	   );



##### Main ###################################################################

my $q = new CGI;
my @out;

my $size = "";
my $font = 'n';


print
  $q->header,
  $q->start_html(-title   => "morannon.fido.de Gateway Status",
		 -author  => 'mj@fido.de',
		 -bgcolor => '#ffffff'    ), "\n\n",
  $q->h1("morannon.fido.de Gateway Status"), "\n",
  $q->b("Date: " . localtime(time)), $q->br, $q->br, $q->br,
  $q->hr, "\n";

$font = $q->param('font');
$size = "size=-1" if($font eq 's');
$size = ""        if($font eq 'n');


@out = my_run("uptime");
print
  "<b>Uptime</b>\n",
  "<font $size>\n",
  "<pre>",
  @out,
  "</pre>\n",
  "</font>\n";

print
  $q->hr, "\n";

@out = my_run("free");
print
  "<b>Free</b>\n",
  "<font $size>\n",
  "<pre>",
  @out,
  "</pre>\n",
  "</font>\n";

print
  $q->hr, "\n";

@out = my_run("who");
print
  "<b>Who</b>\n",
  "<font $size>\n",
  "<pre>",
  @out,
  "</pre>\n",
  "</font>\n";

print
  $q->hr, "\n";

@out = my_run("last -20");
print
  "<b>Last Logins</b>\n",
  "<font $size>\n",
  "<pre>",
  @out,
  "</pre>\n",
  "</font>\n";

print
  $q->hr, "\n";

@out = my_run("df");
print
  "<b>Disk Space</b>\n",
  "<font $size>\n",
  "<pre>",
  @out,
  "</pre>\n",
  "</font>\n";

print
  $q->hr, "\n";

@out = my_ps_news();
print
  "<b>News Processes</b>\n",
  "<font $size>\n",
  "<pre>\n",
  @out,
  "</pre>\n",
  "</font>\n";

my ($dir, $opts);

for (@DIRS) {
    ($dir, $opts) = split(' ');
    next if(! -d $dir);
    
    print
      $q->hr, "\n";
    @out = my_ls_l($dir, $opts);
    print
      "<b>Directory $dir</b>\n",
      "<font $size>\n",
      "<pre>",
      @out,
      "</pre>\n",
      "</font>\n";
}


print
  $q->hr, "\n",
  $q->p, "\n",
  '<font size=-2>FIDOGATE $Id: gate.cgi.in,v 1.1.1.1 2003/09/23 17:37:27 rusfidogate Exp $ <br>',
  '&copy; Copyright 1990-2000 ',
  '<a href="mailto:mj@fido.de">Martin Junius</a></font>',
  $q->end_html, "\n";

exit 0;



##### Run normal command and return output ###################################

sub my_run {
    my($cmd) = @_;

    my($tmp,@lines);
    local(*F);

    $tmp = "/tmp/gate.cgi.out.$$";
    system "$cmd >$tmp 2>&1";
    open(F, $tmp) || return ("ERROR");
    while(<F>) {
	push(@lines, $_);
    }
    close(F);
    unlink($tmp);
#    chop @lines;

    return @lines;
}



##### Run ps command and return post-processed output ########################

sub my_ps_news {
    my($tmp,@lines,$s,$x,$x1,$x2);
    local(*F);

#    $tmp = "/home/mj/psaux.morannon";
    $tmp = "/tmp/gate.cgi.out.$$";
    system "ps auxww >$tmp 2>/dev/null";
    open(F, $tmp) || return ("ERROR");
    while(<F>) {
	if( /^USER/ ) {
#	    push(@lines, "  PID %CPU %MEM  SIZE   RSS STAT START    TIME COMMAND\n");
	    push(@lines, "  PID %CPU %MEM   VSZ  RSS  STAT START    TIME COMMAND\n");
	    next;
	}
	next if(! /^news/ );

#	push(@lines, ">>>$_");

#  USER     (  PID %CPU %MEM   VSZ  RSS )TTY      STAT START   TIME COMMAND
#  news     (  580  0.0  0.2  5604  136 )?        S    10:18   0:01 /usr/bin/innd -p5
#  news     (  584  0.0  0.1  2536  100 )?        S    10:18   0:00 /usr/bin/actived
#/^.........(...........................)......*?([A-Z].*\d )( *\d+:\d\d).(.+)$/ );
	next if(! /^.........(...........................)......*?([A-Z].*\d )( *\d+:\d\d).(.+)$/ );
	$x  = "$1 $2";
	$x1 = $3;
	$x2 = $4;
	$x1 = " ". $x1 if(($x1 =~ /^ /) || ($x1 =~ /^\d\d\d:/));
	$x .= $x1;
	$_  = $x2;
	next if( /^time / );
	s/^sh //;
	s/^sh -c //;
	s/^perl //;
	s/^\/[a-zA-Z0-9\/.\-]*\///;
	$x = "$x $_";
	$x =~ s/^(.{1,110}).*$/$1/;
	push(@lines, "$x\n");
    }
    close(F);
    unlink($tmp);
#    chop @lines;

    return @lines;
}



##### Run ls -l command and return output ####################################

sub my_ls_l {
    my($dir, $opts) = @_;

    my($tmp,@lines);
    local(*F);

    @lines = ();

    $tmp = "/tmp/gate.cgi.out.$$";
    system "ls -lL $opts $dir >$tmp 2>/dev/null";
    open(F, $tmp) || return ("ERROR");
    while(<F>) {
	next if( /^total/ || /^d/ );
	s/ (\d{9}) /$1 /;
	push(@lines, $_);
    }
    close(F);
    unlink($tmp);
#    chop @lines;

    return @lines;
}
